#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		srvname		postgres
%define		sname		pgsql
#-----------------------------------------------------------------------------
Name		:	postgresql
Version		:	15.3
Release		:	14.4.0.0%{?dist}
Summary		:	PostgreSQL is an advanced object-relational database management system 
Group		:	Applications/Internet

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	PostgreSQL
URL		:	http://www.postgresql.org/

Source0		:	%{name}-%{version}.tar.bz2
Source1		:	%{name}-ok_addon.tar.gz
#-----------------------------------------------------------------------------
BuildRequires	:	bison
BuildRequires	:	flex
BuildRequires	:	gawk
BuildRequires	:	gcc
#BuildRequires	:	llvm-devel
#BuildRequires	:	llvm-clang
BuildRequires	:	perl
BuildRequires	:	util-linux
BuildRequires	:	zlib

#-----------------------------------------------------------------------------
%description
PostgreSQL is an advanced Object-Relational database management system (DBMS).
The base postgresql package contains the client programs that you'll need to
access a PostgreSQL DBMS server, as well as HTML documentation for the whole
system.  These client programs can be located on the same machine as the
PostgreSQL server, or on a remote machine that accesses a PostgreSQL server
over a network connection. 

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%license COPYRIGHT
%doc README
%{_includedir}/*.h
%{_includedir}/libpq/*.h
%{_includedir}/%{name}/internal/*.h
%{_includedir}/%{name}/internal/libpq/*.h
%{_bindir}/clusterdb
%{_bindir}/createdb
%{_bindir}/createuser
%{_bindir}/dropdb
%{_bindir}/dropuser
%{_bindir}/pg_dump
%{_bindir}/pg_dumpall
%{_bindir}/pg_isready
%{_bindir}/pg_restore
%{_bindir}/pg_upgrade
%{_bindir}/psql
%{_bindir}/reindexdb
%{_bindir}/vacuumdb
%{_libdir}/libpq.so*
%{_libdir}/%{name}/*.so
%{_libdir}/pkgconfig/lib*.pc
%{_libdir}/%{name}/pgxs/*
%{_datadir}/%{sname}/*.sample
%{_datadir}/%{sname}/*.txt
%{_datadir}/%{sname}/*.sql
%{_datadir}/%{sname}/%{srvname}.*
%{_datadir}/%{sname}/timezonesets/Australia
%{_datadir}/%{sname}/timezonesets/Default
%{_datadir}/%{sname}/timezonesets/India
%{_datadir}/%{sname}/timezonesets/*.txt
%{_datadir}/%{sname}/tsearch_data/*.{affix,dict,rules,stop}
%{_datadir}/%{sname}/tsearch_data/synonym_sample.syn
%{_datadir}/%{sname}/tsearch_data/thesaurus_sample.ths
%{_defaultdocdir}/%{name}-%{version}/html/*.html
%{_defaultdocdir}/%{name}-%{version}/html/stylesheet.css
%{_defaultdocdir}/%{name}-%{version}/html/gin.svg
%{_defaultdocdir}/%{name}-%{version}/html/pagelayout.svg
%{_defaultdocdir}/%{name}-%{version}/extension/*.example
%{_mandir}/man1/clusterdb.1.gz
%{_mandir}/man1/createdb.1.gz
%{_mandir}/man1/createuser.1.gz
%{_mandir}/man1/dropdb.1.gz
%{_mandir}/man1/dropuser.1.gz
%{_mandir}/man1/pg_dump.1.gz
%{_mandir}/man1/pg_dumpall.1.gz
%{_mandir}/man1/pg_isready.1.gz
%{_mandir}/man1/pg_restore.1.gz
%{_mandir}/man1/pg_upgrade.1.gz
%{_mandir}/man1/psql.1.gz
%{_mandir}/man1/reindexdb.1.gz
%{_mandir}/man1/vacuumdb.1.gz
%{_mandir}/man7/*.7.gz


#=============================================================================
%package		server
Summary		:	The programs needed to create and run a PostgreSQL server

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

Requires	:	chkconfig
Requires	:	/usr/sbin/useradd, /usr/sbin/userdel
Requires	:	/usr/sbin/groupadd, /usr/sbin/groupdel
Requires	:	lfs-bootscripts
Requires	:	sudo,util-linux


#-----------------------------------------------------------------------------
%description		server
PostgreSQL is an advanced Object-Relational database management
system (DBMS).
The postgresql-server package contains the programs needed to create
and run a PostgreSQL server, which will in turn allow you to create
and maintain PostgreSQL databases.
 

#-----------------------------------------------------------------------------
%files			server
%defattr(-,root,root,-)
%attr(0700,postgres,postgres) %dir %{_var}/lib/pgsql/data
%attr(0744,root,root) %{_sysconfdir}/rc.d/init.d/%{name}
%{_bindir}/initdb
%{_bindir}/pg_basebackup
%{_bindir}/pg_controldata
%{_bindir}/pg_ctl
%{_bindir}/pg_receivewal
%{_bindir}/pg_recvlogical
%{_bindir}/pg_resetwal
%{_bindir}/pg_rewind
%{_bindir}/pg_checksums
%{_bindir}/pg_config
%{_bindir}/pg_verifybackup
%{_bindir}/postgres
%{_bindir}/postmaster
%{_datadir}/%{sname}/information_schema.sql
%{_datadir}/%{sname}/snowball_create.sql
%{_datadir}/%{sname}/sql_features.txt
%{_datadir}/%{sname}/system_views.sql
%{_datadir}/%{sname}/timezonesets/
%{_datadir}/%{sname}/tsearch_data/
%{_datadir}/%{sname}/*.sample
%{_datadir}/%{sname}/postgres.bki
%{_datadir}/%{sname}/extension/plpgsql*
%{_datadir}/%{sname}/extension/uuid-*
%{_datadir}/%{sname}/extension/bool_*
%{_mandir}/man1/initdb.1.gz
%{_mandir}/man1/pg_basebackup.1.gz
%{_mandir}/man1/pg_verifybackup.1.gz
%{_mandir}/man1/pg_controldata.1.gz
%{_mandir}/man1/pg_ctl.1.gz
%{_mandir}/man1/pg_receivewal.1.gz
%{_mandir}/man1/pg_resetwal.1.gz
%{_mandir}/man1/pg_rewind.1.gz
%{_mandir}/man1/pg_checksums.1.gz
%{_mandir}/man1/pg_config.1.gz
%{_mandir}/man1/postgres.1.gz
%{_mandir}/man1/postmaster.1.gz
%{_mandir}/man7/*.7.gz

#-----------------------------------------------------------------------------
%pre		server
if [ "$1" = 1 ]; then
  if [ ! $(getent group %{srvname}) ]; then
    /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{srvname}

    /usr/sbin/useradd 				\
	-r					\
	-c "PostgreSQL Server"			\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{srvname}				\
	-s /bin/bash				\
	-d %{_var}/lib/pgsql			\
	%{srvname}
    fi
  fi

#after upgrade or remove
%preun		server
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del %{name}
  /usr/sbin/userdel %{srvname}
  %{__rm} -fr %{_var}/lib/pgsql/data/*
  (
  /bin/echo -n "%{name}-%{version}-%{release} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi
#-----------------------------------------------------------------------------
%post		server
/sbin/chkconfig --add %{name}
%{_sysconfdir}/rc.d/init.d/%{name} condrestart > /dev/null 2>&1 || :

#=============================================================================
%package		server-devel
Summary		:	PostgreSQL development header files and libraries

#-----------------------------------------------------------------------------
Requires	:	%{name}-server	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		server-devel
The postgresql-server-devel package contains the header files and configuration
needed to compile PostgreSQL server extension.

#-----------------------------------------------------------------------------
%files			server-devel
%defattr(-,root,root,-)
%{_includedir}/%{name}/server/*.h
%{_includedir}/%{name}/server/access/*.h
%{_includedir}/%{name}/server/bootstrap/*.h
%{_includedir}/%{name}/server/catalog/*.h
%{_includedir}/%{name}/server/commands/*.h
%{_includedir}/%{name}/server/common/*.h
%{_includedir}/%{name}/server/datatype/*.h
%{_includedir}/%{name}/server/executor/*.h
%{_includedir}/%{name}/server/extension/*/*.h
%{_includedir}/%{name}/server/fe_utils/*.h
%{_includedir}/%{name}/server/foreign/*.h
%{_includedir}/%{name}/server/jit/*.h
%{_includedir}/%{name}/server/lib/*.h
%{_includedir}/%{name}/server/libpq/*.h
%{_includedir}/%{name}/server/mb/*.h
%{_includedir}/%{name}/server/nodes/*.h
%{_includedir}/%{name}/server/optimizer/*.h
%{_includedir}/%{name}/server/parser/*.h
%{_includedir}/%{name}/server/partitioning/part*.h
%{_includedir}/%{name}/server/port/*.h
%{_includedir}/%{name}/server/port/atomics/*.h
%{_includedir}/%{name}/server/port/win32/*.h
%{_includedir}/%{name}/server/port/win32/arpa/*.h
%{_includedir}/%{name}/server/port/win32/netinet/*.h
%{_includedir}/%{name}/server/port/win32/sys/*.h
%{_includedir}/%{name}/server/port/win32_msvc/*.h
%{_includedir}/%{name}/server/port/win32_msvc/sys/*.h
%{_includedir}/%{name}/server/portability/*.h
%{_includedir}/%{name}/server/postmaster/*.h
%{_includedir}/%{name}/server/regex/*.h
%{_includedir}/%{name}/server/replication/*.h
%{_includedir}/%{name}/server/rewrite/*.h
%{_includedir}/%{name}/server/snowball/*.h
%{_includedir}/%{name}/server/snowball/libstemmer/*.h
%{_includedir}/%{name}/server/statistics/*.h
%{_includedir}/%{name}/server/storage/*.h
%{_includedir}/%{name}/server/tcop/*.h
%{_includedir}/%{name}/server/tsearch/*.h
%{_includedir}/%{name}/server/tsearch/dicts/*.h
%{_includedir}/%{name}/server/utils/*.h
#{_bindir}/ecpg
%{_datadir}/%{sname}/errcodes.txt
%{_mandir}/man1/ecpg.1.gz
%{_mandir}/man3/SPI_*.3.gz

#=============================================================================
%package		static
Summary		:	Statically linked PostgreSQL libraries

#-----------------------------------------------------------------------------
Requires	:	%{name}-server-devel	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		static
Statically linked PostgreSQL libraries that do not have dynamically linked
counterparts.

#-----------------------------------------------------------------------------
%files			static
%defattr(-,root,root,-)
%{_libdir}/libpgcommon.a
%{_libdir}/libpgfeutils.a
%{_libdir}/libpgport.a
%{_libdir}/libpgcommon_shlib.a
%{_libdir}/libpgport_shlib.a
%{_libdir}/libpq.a

#=============================================================================
%package		contrib
Summary		:	Extension modules distributed with PostgreSQL

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		contrib
The postgresql-contrib package contains various extension
modules that are included in the PostgreSQL distribution.

#-----------------------------------------------------------------------------
%files			contrib
%defattr(-,root,root,-)
%{_bindir}/oid2name
%{_bindir}/pg_archivecleanup
%{_bindir}/pg_amcheck
#{_bindir}/pg_standby
%{_bindir}/pg_test_fsync
%{_bindir}/pg_test_timing
%{_bindir}/pg_waldump
%{_bindir}/pgbench
%{_bindir}/vacuumlo
%{_libdir}/%{name}/sslinfo.so
%{_libdir}/%{name}/pgxml.so
%{_datadir}/%{sname}/extension/adminpack*
%{_datadir}/%{sname}/extension/amcheck*
%{_datadir}/%{sname}/extension/autoinc*
%{_datadir}/%{sname}/extension/bloom*
%{_datadir}/%{sname}/extension/btree_gin*
%{_datadir}/%{sname}/extension/btree_gist*
%{_datadir}/%{sname}/extension/citext*
%{_datadir}/%{sname}/extension/cube*
%{_datadir}/%{sname}/extension/dblink*
%{_datadir}/%{sname}/extension/dict_int*
%{_datadir}/%{sname}/extension/dict_xsyn*
%{_datadir}/%{sname}/extension/earthdistance*
%{_datadir}/%{sname}/extension/file_fdw*
%{_datadir}/%{sname}/extension/fuzzystrmatch*
%{_datadir}/%{sname}/extension/hstore*
%{_datadir}/%{sname}/extension/insert_username*
%{_datadir}/%{sname}/extension/intagg*
%{_datadir}/%{sname}/extension/intarray*
%{_datadir}/%{sname}/extension/isn*
%{_datadir}/%{sname}/extension/lo*
%{_datadir}/%{sname}/extension/ltree*
%{_datadir}/%{sname}/extension/moddatetime*
%{_datadir}/%{sname}/extension/pageinspect*
%{_datadir}/%{sname}/extension/old_snapshot*
%{_datadir}/%{sname}/extension/pg_buffercache*
%{_datadir}/%{sname}/extension/pg_freespacemap*
%{_datadir}/%{sname}/extension/pg_prewarm*
%{_datadir}/%{sname}/extension/pg_stat_statements*
%{_datadir}/%{sname}/extension/pg_trgm*
%{_datadir}/%{sname}/extension/pg_visibility*
%{_datadir}/%{sname}/extension/pgcrypto*
%{_datadir}/%{sname}/extension/pgrowlocks*
%{_datadir}/%{sname}/extension/pgstattuple*
%{_datadir}/%{sname}/extension/pg_surgery*
%{_datadir}/%{sname}/extension/pg_walinspect*
%{_datadir}/%{sname}/extension/postgres_fdw*
%{_datadir}/%{sname}/extension/refint*
%{_datadir}/%{sname}/extension/seg*
%{_datadir}/%{sname}/extension/tablefunc*
%{_datadir}/%{sname}/extension/tcn*
%{_datadir}/%{sname}/extension/tsm_system_rows*
%{_datadir}/%{sname}/extension/tsm_system_time*
%{_datadir}/%{sname}/extension/unaccent*
%{_datadir}/%{sname}/extension/jsonb_plperl*
%{_datadir}/%{sname}/extension/jsonb_plpython3u*
%{_datadir}/%{sname}/extension/plperl*
%{_datadir}/%{sname}/extension/sslinfo*
%{_datadir}/%{sname}/extension/xml2*
%{_mandir}/man1/oid2name.1.gz
%{_mandir}/man1/pg_archivecleanup.1.gz
#{_mandir}/man1/pg_standby.1.gz
%{_mandir}/man1/pg_amcheck.1.gz
%{_mandir}/man1/pg_recvlogical.1.gz
%{_mandir}/man1/pg_test_fsync.1.gz
%{_mandir}/man1/pg_test_timing.1.gz
%{_mandir}/man1/pg_waldump.1.gz
%{_mandir}/man1/vacuumlo.1.gz
%{_mandir}/man1/pgbench.1.gz
%{_mandir}/man3/dblink*.3.gz

#=============================================================================
%package		plpython
Summary		:	The Python2 procedural language for PostgreSQL

#-----------------------------------------------------------------------------

Requires	:	%{name}-server	= %{version}-%{release}

Provides	:	%{name}-plpython3 = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		plpython
The postgresql-plpython package contains the PL/Python procedural language,
which is an extension to the PostgreSQL database server.
Install this if you want to write database functions in Python 2

#-----------------------------------------------------------------------------
%files			plpython
%defattr(-,root,root,-)
%{_datadir}/%{sname}/extension/plpython3u*

#=============================================================================
%package		docs
Summary		:	Extra documentation for PostgreSQL

BuildArch	:	noarch
#-----------------------------------------------------------------------------

Requires	:	%{name}		= %{version}-%{release}

Provides	:	%{name}-docs	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		docs
The postgresql-docs package contains some additional html documentation for
PostgreSQL.

#-----------------------------------------------------------------------------
%files			docs
%defattr(-,root,root,-)
%{_defaultdocdir}/%{name}-%{version}/html/*

#=============================================================================
%prep
%setup -q

sed -i							\
  -e "s/libpq ecpg/libpq/"				\
  src/interfaces/Makefile

#-----------------------------------------------------------------------------
#building application
%build

tar xf %{SOURCE1}
sed -i							\
  -e "/DEFAULT_PGSOCKET_DIR/s@/tmp@/run/postgresql@"	\
  src/include/pg_config_manual.h

cat >> src/backend/utils/misc/postgresql.conf.sample << EOF
#-----------------------------------------
#added by Osukiss
log_destination = 'stderr'		# Valid values are combinations of
logging_collector = 'on'		# Enable capturing of stderr, jsonlog,
log_directory = 'log'			# directory where log files are written,
					# can be absolute or relative to PGDATA
log_filename = 'postgresql-%Y-%m-%d.log'# log file name pattern,
					# can include strftime() escapes
log_file_mode = 0600			# creation mode for log files,
					# begin with 0 to use octal notation
log_rotation_age = 1d			# Automatic rotation of logfiles will
					# happen after that time.  0 disables.
log_rotation_size = 10MB		# Automatic rotation of logfiles will
					# happen after that much log output.
					# 0 disables.

#-----------------------------------------
EOF

#fix deprecated TRUE define within ICU_68
#must be replaced with true
sed -i							\
  -e"s/, TRUE/, true/"					\
  ./src/backend/commands/collationcmds.c

PYTHON=/usr/bin/python3	
./configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}/%{name}		\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--datadir=%{_datadir}/%{sname}			\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--with-libxml					\
	--with-openssl					\
	--with-perl					\
	--with-python					\
	--with-pam=no					\
	--with-system-tzdata=%{_datadir}/zoneinfo	\
	--with-uuid=e2fs				\
	--with-icu					\
	--with-systemd=no				\
	--with-ldap					\
	--with-llvm=no					\
	--enable-thread-safety				\

sed -i							\
  -e "s/LDAP_LIBS_FE = -lldap_r/LDAP_LIBS_FE = -lldap/"	\
  ./src/Makefile.global

#	enable_thread_safety=no				\

%{__make}						\
	 -C ./src/backend generated-headers

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	%{_smp_mflags}					\
	all

%{__make}						\
	-C contrib					\
	%{_smp_mflags}					\
	all

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
%check
#make check doesn't work within rpmbuild (??)
#%{__make} check

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make} DESTDIR=%{buildroot} install
%{__make} DESTDIR=%{buildroot} install-docs
%{__make} -C contrib DESTDIR=%{buildroot} install

#defining the application data-base directory
%{__mkdir_p} %{buildroot}%{_var}/lib/pgsql/data

#installing postgresql starting/stopping script
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} -a 						\
	%{name}-ok_addon/%{name}			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
